package com.zg.project.wisdom.service;

import java.util.List;
import java.util.Map;

import com.zg.project.wisdom.domain.RkInfo;
import com.zg.project.wisdom.domain.dto.PcRkInfoBatchDTO;
import com.zg.project.wisdom.domain.dto.RkInfoBatchDTO;
import com.zg.project.wisdom.domain.dto.StockOutDTO;

/**
 * 库存单据主Service接口
 * 
 * @author zg
 * @date 2025-05-28
 */
public interface IRkInfoService 
{
    /**
     * 查询库存单据主
     * 
     * @param id 库存单据主主键
     * @return 库存单据主
     */
    public RkInfo selectRkInfoById(Long id);

    /**
     * 查询库存单据主列表
     * 
     * @param rkInfo 库存单据主
     * @return 库存单据主集合
     */
    public List<RkInfo> selectRkInfoList(RkInfo rkInfo);


    /**
     * 修改库存单据主
     * 
     * @param rkInfo 库存单据主
     * @return 结果
     */
    public int updateRkInfo(RkInfo rkInfo);

    /**
     * 批量删除库存单据主
     * 
     * @param ids 需要删除的库存单据主主键集合
     * @return 结果
     */
    public int deleteRkInfoByIds(Long[] ids);

    /**
     * 删除库存单据主信息
     * 
     * @param id 库存单据主主键
     * @return 结果
     */
    public int deleteRkInfoById(Long id);

    /**
     * PC新增入库单据
     * @param dto
     * @return
     */
    int batchInsert(PcRkInfoBatchDTO dto);

    /**
     * APP新增入库单据
     * @param dto
     * @return
     */
    int batchInsertApp(RkInfoBatchDTO dto);

    /**
     * 根据单据编号删除入库单据
     * @param billNo
     */
    void deleteByBillNo(String billNo);

    /**
     * 统计逾期库存数量
     * @return
     */
    int countOverdueStock();

    /**
     * 获取最新20条逾期库存列表
     * @param i
     * @return
     */
    List<RkInfo> selectTopOverdueStock(int i);

    /**
     * 出库操作
     * @param dto
     * @return
     */
    int updateOutStock(StockOutDTO dto);
}
